import { Optional, Resource } from "../../common";
import { APIMarkerSymptom, StoreMarkerSymptom } from "./interfaces";
export declare class MarkerSymptom extends Resource {
    /**
     * Name of the symptom.
     */
    name: string;
    constructor(name: string);
    /**
     * The name of the marker symptom resource on the API server.
     */
    static get resourceName(): string;
    /**
     * The name of the service containing the marker symptom resource.
     */
    static get serviceName(): string;
    /**
     * Convert the marker symptom into a JSON serializable object for the API server.
     */
    serializeAPI(): Optional<APIMarkerSymptom, "id">;
    /**
     * Deserialize the data from the API server.
     *
     * @param data The marker symptom data from the API server.
     */
    deserializeAPI(data: APIMarkerSymptom): void;
    /**
     * Serialize the marker symptom into a format for storing in the Redux store.
     */
    serializeRedux(): StoreMarkerSymptom;
    /**
     * Create a marker symptom from the API server data.
     *
     * @param data Data from the api server.
     *
     * @returns The marker symptom object.
     */
    static apiFactory(data: APIMarkerSymptom): MarkerSymptom;
    /**
     * Create a marker symptom from the Redux store data.
     *
     * @param data Data from the api server.
     *
     * @returns The marker symptom object.
     */
    static reduxFactory(data: StoreMarkerSymptom): MarkerSymptom;
}
